/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 21 decembre 2006
   derniere modification le 19/02/2008 */

#include <string.h>

#include <SCE/utils/SCEMath.h>
#include <SCE/utils/SCEVector.h>

#include <SCE/utils/SCEMatrix.h>

/* ajoute le 09/01/2008 */
/* matrice temporaire accessible par l'utilisateur */
SCE_TMatrix4 SCE_TmpMatrix4;

/* valeurs temporaires pour certains calculs */
static float cosinus, sinus, t, t2, t3, t4, val[8];

/* matrices temporaires pour certains calculs */
static SCE_TMatrix4 tm, tm2;

/* vecteurs temporaires pour certains calculs */
static SCE_TVector3 tv, tv2, tv3;

/* economie de bout de chandelle (pataper) */
static unsigned int size;


/* ajoute le 09/01/2008 */
int SCE_Init_Matrix (void)
{
    SCE_Matrix4_LoadIdentity (tm);
    return 0; /* fuck */
}
/* ajoute le 09/01/2008 */
void SCE_Quit_Matrix (void)
{
}


void SCE_Matrix4_LoadIdentity (SCE_TMatrix4 m)
{
    m[0] = m[5] = m[10] = m[15] = 1.0f;
    m[1] = m[2] = m[3] = m[4] = m[6] = m[7] = m[8] =
    m[9] = m[11] = m[12] = m[13] = m[14] = 0.0f;
}

/* ajoute le 10/07/2007 */
void SCE_Matrix4_Copy (SCE_TMatrix4 r, SCE_TMatrix4 n)
{
    n[0] = r[0]; n[1] = r[1]; n[2] = r[2]; n[3] = r[3];
    n[4] = r[4]; n[5] = r[5]; n[6] = r[6]; n[7] = r[7];
    n[8] = r[8]; n[9] = r[9]; n[10] = r[10]; n[11] = r[11];
    n[12] = r[12]; n[13] = r[13]; n[14] = r[14]; n[15] = r[15];
}


/* revise le 11/07/2007 */
float* SCE_Matrix4_Mul4 (SCE_TMatrix4 m, SCE_TMatrix4 n, SCE_TMatrix4 r)
{
    r[0]  = (m[0] *n[0]) + (m[1] *n[4]) + (m[2] *n[8]) + (m[3] *n[12]);
    r[4]  = (m[4] *n[0]) + (m[5] *n[4]) + (m[6] *n[8]) + (m[7] *n[12]);
    r[8]  = (m[8] *n[0]) + (m[9] *n[4]) + (m[10]*n[8]) + (m[11]*n[12]);
    r[12] = (m[12]*n[0]) + (m[13]*n[4]) + (m[14]*n[8]) + (m[15]*n[12]);

    r[1]  = (m[0] *n[1]) + (m[1] *n[5]) + (m[2] *n[9]) + (m[3] *n[13]);
    r[5]  = (m[4] *n[1]) + (m[5] *n[5]) + (m[6] *n[9]) + (m[7] *n[13]);
    r[9]  = (m[8] *n[1]) + (m[9] *n[5]) + (m[10]*n[9]) + (m[11]*n[13]);
    r[13] = (m[12]*n[1]) + (m[13]*n[5]) + (m[14]*n[9]) + (m[15]*n[13]);

    r[2]  = (m[0] *n[2]) + (m[1] *n[6]) + (m[2] *n[10]) + (m[3] *n[14]);
    r[6]  = (m[4] *n[2]) + (m[5] *n[6]) + (m[6] *n[10]) + (m[7] *n[14]);
    r[10] = (m[8] *n[2]) + (m[9] *n[6]) + (m[10]*n[10]) + (m[11]*n[14]);
    r[14] = (m[12]*n[2]) + (m[13]*n[6]) + (m[14]*n[10]) + (m[15]*n[14]);

    r[3]  = (m[0] *n[3]) + (m[1] *n[7]) + (m[2] *n[11]) + (m[3] *n[15]);
    r[7]  = (m[4] *n[3]) + (m[5] *n[7]) + (m[6] *n[11]) + (m[7] *n[15]);
    r[11] = (m[8] *n[3]) + (m[9] *n[7]) + (m[10]*n[11]) + (m[11]*n[15]);
    r[15] = (m[12]*n[3]) + (m[13]*n[7]) + (m[14]*n[11]) + (m[15]*n[15]);

    return r;
}


void SCE_Matrix4_Add (SCE_TMatrix4 a, SCE_TMatrix4 b)
{
    a[0] += b[0]; a[1] += b[1]; a[2] += b[2]; a[3] += b[3];
    a[4] += b[4]; a[5] += b[5]; a[6] += b[6]; a[7] += b[7];
    a[8] += b[8]; a[9] += b[9]; a[10] += b[10]; a[11] += b[11];
    a[12] += b[12]; a[13] += b[13]; a[14] += b[14]; a[15] += b[15];
}

void SCE_Matrix4_Sub (SCE_TMatrix4 a, SCE_TMatrix4 b)
{
    a[0] -= b[0]; a[1] -= b[1]; a[2] -= b[2]; a[3] -= b[3];
    a[4] -= b[4]; a[5] -= b[5]; a[6] -= b[6]; a[7] -= b[7];
    a[8] -= b[8]; a[9] -= b[9]; a[10] -= b[10]; a[11] -= b[11];
    a[12] -= b[12]; a[13] -= b[13]; a[14] -= b[14]; a[15] -= b[15];
}


void SCE_Matrix4_Transpose (SCE_TMatrix4 m)
{
    t = m[1]; m[1] = m[4]; m[4] = t;
    t = m[2]; m[2] = m[8]; m[8] = t;
    t = m[3]; m[3] = m[12]; m[12] = t;
    t = m[6]; m[6] = m[9]; m[9] = t;
    t = m[7]; m[7] = m[13]; m[13] = t;
    t = m[11]; m[11] = m[14]; m[14] = t;
}

/* ajoute le 19/02/2008 */
static float SCE_Matrix4_Determinant (SCE_TMatrix4 m)
{
    t = m[5] * (m[10] * m[15] - m[14] * m[11]) - m[9] *
        (m[6] * m[15] - m[14] * m[7]) + m[13] * (m[6] * m[11] - m[10] * m[7]);
    t2 = m[1] * (m[10] * m[15] - m[14] * m[11]) - m[9] *
        (m[2] * m[15] - m[14] * m[3]) + m[13] * (m[2] * m[11] - m[10] * m[3]);
    t3 = m[1] * (m[6] * m[15] - m[14] * m[7]) - m[5] *
        (m[2] * m[15] - m[14] * m[3]) + m[13] * (m[2] * m[7] - m[6] * m[3]);
    t4 = m[1] * (m[6] * m[11] - m[10] * m[7]) - m[5] *
        (m[2] * m[11] - m[10] * m[3]) + m[9] * (m[2] * m[7] - m[6] * m[3]);

    return m[0] * t - m[4] * t2 + m[8] * t3 - m[12] * t4;
}
/* ajoute le 19/02/2008 */
void SCE_Matrix4_Inverse (SCE_TMatrix4 m)
{
    float d = SCE_Matrix4_Determinant (m);

    if (d != 0.F) /* (fpclassify (x) != FP_ZERO) : C99 */
    {
        SCE_Matrix4_Copy (m, tm);
        m[0] =  (tm[5] * (tm[10]*tm[15]-tm[11]*tm[14]) - tm[9] * (tm[6]*tm[15] -
                 tm[14]*tm[7]) + tm[13] * (tm[6]*tm[11] - tm[10]*tm[7]) ) / d;
        m[1] = -(tm[1] * (tm[10]*tm[15]-tm[14]*tm[11]) - tm[9] * (tm[2]*tm[15] -
                 tm[14]*tm[3]) + tm[13] * (tm[2]*tm[11] - tm[10]*tm[3])) / d;
        m[2] =  (tm[1] * (tm[6]*tm[15]-tm[14]*tm[7]) - tm[5] * (tm[2]*tm[15] -
                 tm[14]*tm[3]) + tm[13] * (tm[2]*tm[7]-tm[6]*tm[3]) ) / d;
        m[3] = -(tm[1] * (tm[6]*tm[11]-tm[10]*tm[7]) - tm[5] * (tm[2]*tm[11] -
                 tm[10]*tm[3]) + tm[9] * (tm[2]*tm[7]-tm[6]*tm[3]) ) / d;

        m[4] = -(tm[4] * (tm[10]*tm[15]-tm[11]*tm[14]) - tm[6] * (tm[8]*tm[15] -
                 tm[11]*tm[12]) + tm[7] * (tm[8]*tm[14]-tm[10]*tm[12]) ) / d;
        m[5] =  (tm[0] * (tm[10]*tm[15]-tm[11]*tm[14]) - tm[2] * (tm[8]*tm[15] -
                 tm[11]*tm[12]) + tm[3] * (tm[8]*tm[14]-tm[10]*tm[12]) ) / d;
        m[6] = -(tm[0] * (tm[6]*tm[15]-tm[7]*tm[14]) - tm[2] * (tm[4]*tm[15] -
                 tm[7]*tm[12]) + tm[3] * (tm[4]*tm[14]-tm[6]*tm[12]) ) / d;
        m[7] =  (tm[0] * (tm[6]*tm[11]-tm[7]*tm[10]) - tm[2] * (tm[4]*tm[11] -
                 tm[7]*tm[8]) + tm[3] * (tm[4]*tm[10]-tm[6]*tm[8]) ) / d;

        m[8] =  (tm[4] * (tm[9]*tm[15]-tm[11]*tm[13]) - tm[5] * (tm[8]*tm[15] -
                 tm[11]*tm[12]) + tm[7] * (tm[8]*tm[13]-tm[9]*tm[12]) ) / d;
        m[9] = -(tm[0] * (tm[9]*tm[15]-tm[11]*tm[13]) - tm[1] * (tm[8]*tm[15] -
                 tm[11]*tm[12]) + tm[3] * (tm[8]*tm[13]-tm[9]*tm[12]) ) / d;
        m[10] =  (tm[0] * (tm[5]*tm[15]-tm[7]*tm[13]) - tm[1] * (tm[4]*tm[15] -
                  tm[7]*tm[12]) + tm[3] * (tm[4]*tm[13]-tm[5]*tm[12]) ) / d;
        m[11] = -(tm[0] * (tm[5]*tm[11]-tm[7]*tm[9]) - tm[1] * (tm[4]*tm[11] -
                  tm[7]*tm[8]) + tm[3] * (tm[4]*tm[9]-tm[5]*tm[8]) ) / d;

        m[12] = -(tm[4] * (tm[9]*tm[14]-tm[10]*tm[13]) - tm[5] * (tm[8]*tm[14] -
                  tm[10]*tm[12]) + tm[6] * (tm[8]*tm[13]-tm[9]*tm[12]) ) / d;
        m[13] =  (tm[0] * (tm[9]*tm[14]-tm[10]*tm[13]) - tm[1] * (tm[8]*tm[14] -
                  tm[10]*tm[12]) + tm[2] * (tm[8]*tm[13]-tm[9]*tm[12]) ) / d;
        m[14] = -(tm[0] * (tm[5]*tm[14]-tm[6]*tm[13]) - tm[1] * (tm[4]*tm[14] -
                  tm[6]*tm[12]) + tm[2] * (tm[4]*tm[13]-tm[5]*tm[12]) ) / d;
        m[15] =  (tm[0] * (tm[5]*tm[10]-tm[6]*tm[9]) - tm[1] * (tm[4]*tm[10] -
                  tm[6]*tm[8]) + tm[2] * (tm[4]*tm[9]-tm[5]*tm[8]) ) / d;
    }
}


/* ajoute le 12/07/2007 */
void SCE_Matrix4_Translate (SCE_TMatrix4 m, float x, float y, float z)
{
    m[3] = x; m[7] = y; m[11] = z;
    m[0] = m[5] = m[10] = m[15] = 1.0f;
    m[1] = m[2] = m[4]  = m[6] = m[14] =
    m[8] = m[9] = m[12] = m[13] = 0.0f;
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_Translatev (SCE_TMatrix4 m, SCE_TVector3 v)
{
    m[3] = v[0]; m[7] = v[1]; m[11] = v[2];
    m[0] = m[5] = m[10] = m[15] = 1.0f;
    m[1] = m[2] = m[4]  = m[6] = m[14] =
    m[8] = m[9] = m[12] = m[13] = 0.0f;
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulTranslate (SCE_TMatrix4 m, float x, float y, float z)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_Translate (tm, x, y, z);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulTranslatev (SCE_TMatrix4 m, SCE_TVector3 v)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_Translatev (tm, v);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}


/* revise le 12/07/2007 */
void SCE_Matrix4_RotX (SCE_TMatrix4 m, float a)
{
    cosinus = cos (a);
    sinus = sin (a);

    m[5] = cosinus;
    m[6] = -sinus;
    m[9] = sinus;
    m[10] = cosinus;
    m[0] = m[15] = 1.0f;
    m[1] = m[2] = m[3] = m[4] = m[7] = m[8] =
    m[11] = m[12] = m[13] = m[14] = 0.0f;
}

/* revise le 12/07/2007 */
void SCE_Matrix4_RotY (SCE_TMatrix4 m, float a)
{
    cosinus = cos (a);
    sinus = sin (a);

    m[0] = cosinus;
    m[2] = -sinus;
    m[8] = sinus;
    m[10] = cosinus;
    m[5] = m[15] = 1.0f;
    m[1] = m[3] = m[4] = m[6] = m[7] = m[9] =
    m[11] = m[12] = m[13] = m[14] = 0.0f;
}

/* revise le 12/07/2007 */
void SCE_Matrix4_RotZ (SCE_TMatrix4 m, float a)
{
    cosinus = cos (a);
    sinus = sin (a);

    m[0] = cosinus;
    m[1] = -sinus;
    m[4] = sinus;
    m[5] = cosinus;
    m[10] = m[15] = 1.0f;
    m[2] = m[3] = m[6] = m[7] = m[8] = m[9] =
    m[11] = m[12] = m[13] = m[14] = 0.0f;
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulRotX (SCE_TMatrix4 m, float a)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_RotX (tm, a);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulRotY (SCE_TMatrix4 m, float a)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_RotY (tm, a);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulRotZ (SCE_TMatrix4 m, float a)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_RotZ (tm, a);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}


/* revise le 19/02/2008 */
void SCE_Matrix4_Rotate (SCE_TMatrix4 m, float a, float x, float y, float z)
{
    #define UN_COS 0
    #define XSIN 1
    #define YSIN 2
    #define ZSIN 3
    #define XY 4
    #define XZ 5
    #define YZ 6

    cosinus = cos (a);
    sinus = sin (a);

    val[UN_COS] = 1.0f - cosinus;

    val[XSIN] = x * sinus;
    val[YSIN] = y * sinus;
    val[ZSIN] = z * sinus;

    val[XY] = x * y;
    val[XZ] = x * z;
    val[YZ] = y * z;

    m[0] = (x*x*val[UN_COS]) + cosinus;
    m[1] = (val[XY]*val[UN_COS]) - val[ZSIN];
    m[2] = (val[XZ]*val[UN_COS]) + val[YSIN];

    m[4] = (val[XY]*val[UN_COS]) + val[ZSIN];
    m[5] = (y*y*val[UN_COS]) + cosinus;
    m[6] = (val[YZ]*val[UN_COS]) - val[XSIN];

    m[8] = (val[XZ]*val[UN_COS]) - val[YSIN];
    m[9] = (val[YZ]*val[UN_COS]) + val[XSIN];
    m[10] = (z*z*val[UN_COS]) + cosinus;

    m[3] = m[7] = m[11] = m[12] = m[13] = m[14] = 0.0f;
    m[15] = 1.0f;

    #undef UN_COS
    #undef XSIN
    #undef YSIN
    #undef ZSIN
    #undef XY
    #undef XZ
    #undef YZ
}

/* ajoute le 23/06/2007 */
void SCE_Matrix4_Rotatev (SCE_TMatrix4 m, float a, SCE_TVector3 axe)
{
    SCE_Matrix4_Rotate (m, a, axe[0], axe[1], axe[2]);
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulRotate (SCE_TMatrix4 m, float a, float x, float y, float z)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_Rotate (tm, a, x, y, z);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulRotatev (SCE_TMatrix4 m, float a, SCE_TVector3 v)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_Rotatev (tm, a, v);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}


/* ajoute le 12/07/2007 */
void SCE_Matrix4_Scale (SCE_TMatrix4 m, float x, float y, float z)
{
    m[0] = x; m[5] = y; m[10] = z; m[15] = 1.0f;
    m[1] = m[2] = m[3] = m[4] =
    m[6] = m[7] = m[8] = m[9] =
    m[11] = m[12] = m[13] = m[14] = 0.0f;
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_Scalev (SCE_TMatrix4 m, SCE_TVector3 v)
{
    m[0] = v[0]; m[5] = v[1]; m[10] = v[2]; m[15] = 1.0f;
    m[1] = m[2] = m[3] = m[4] =
    m[6] = m[7] = m[8] = m[9] =
    m[11] = m[12] = m[13] = m[14] = 0.0f;
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulScale (SCE_TMatrix4 m, float x, float y, float z)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_Scale (tm, x, y, z);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}

/* ajoute le 12/07/2007 */
void SCE_Matrix4_MulScalev (SCE_TMatrix4 m, SCE_TVector3 v)
{
    SCE_Matrix4_Copy (m, tm2);
    SCE_Matrix4_Scalev (tm, v);
    SCE_Matrix4_Mul4 (tm2, tm, m);
}


void SCE_Matrix4_MulV3 (SCE_TMatrix4 m, SCE_TVector3 v)
{
    tv[0] = m[0]*v[0] + m[1]*v[1] + m[2]*v[2] + m[3];
    tv[1] = m[4]*v[0] + m[5]*v[1] + m[6]*v[2] + m[7];
    v[2] = m[8]*v[0] + m[9]*v[1] + m[10]*v[2] + m[11];
    v[0] = tv[0];
    v[1] = tv[1];
}
/* ajoute le 23/02/2008 */
void SCE_Matrix4_MulV4 (SCE_TMatrix4 m, SCE_TVector4 v)
{
    tv[0] = m[0]*v[0]  + m[1]*v[1]  + m[2]*v[2]  + m[3]*v[3];
    tv[1] = m[4]*v[0]  + m[5]*v[1]  + m[6]*v[2]  + m[7]*v[3];
    tv[2] = m[8]*v[0]  + m[9]*v[1]  + m[10]*v[2] + m[11]*v[3];
    v[3]  = m[12]*v[0] + m[13]*v[1] + m[14]*v[2] + m[15]*v[3];
    v[0]  = tv[0];
    v[1]  = tv[1];
    v[2]  = tv[2];
}


/* revise le 23/02/2008 */
void SCE_Matrix4_Projection (SCE_TMatrix4 m, float a, float r, float n, float f)
{
    m[5] = 1.0f / tan (a * 0.5f);
    m[0] = m[5] / r;
    m[10] = -f / (f - n * 2.0f);
    m[11] = -2.0f * n * (f / (f - n));
    m[14] = -1.0f;

    m[1] = m[2] = m[3] = m[4] = m[6] = m[7] =
        m[8] = m[9] = m[12] = m[13] = m[15] = 0.0f;
}


/* TODO: a tester */
void SCE_Matrix4_LookAt (SCE_TMatrix4 m, SCE_TVector3 pos,
                         SCE_TVector3 view, SCE_TVector3 up)
{
    /* TODO : gerer le cas ou (view - pos) et up sont colineaires */

    /*
     * tv  = X axis
     * tv2 = Y axis
     * tv3 = Z axis
     */
    SCE_Vector3_Operator2v (tv3, =, view, - , pos);
    SCE_Vector3_Normalize (tv3);
    SCE_Vector3_Cross (tv, up, tv3);
    SCE_Vector3_Normalize (tv);
    SCE_Vector3_Cross (tv2, tv3, tv);

    size = 3 * sizeof *tv;
    memcpy (m,     tv,  size);
    memcpy (&m[4], tv2, size);
    memcpy (&m[8], tv3, size);
    m[3]  = -SCE_Vector3_Dot (tv, pos);
    m[7]  = -SCE_Vector3_Dot (tv2, pos);
    m[11] = -SCE_Vector3_Dot (tv3, pos);
    m[12] = m[13] = m[14] = 0.0f;
    m[15] = 1.0f;
}
